Attribute VB_Name = "modFile"
Option Explicit


Type SECURITY_ATTRIBUTES
        nLength As Long
        lpSecurityDescriptor As Long
        bInheritHandle As Long
End Type

Type FILETIME
        dwLowDateTime As Long
        dwHighDateTime As Long
End Type

Type ACL
        AclRevision As Byte
        Sbz1 As Byte
        AclSize As Integer
        AceCount As Integer
        Sbz2 As Integer
End Type

Type SECURITY_DESCRIPTOR
        Revision As Byte
        Sbz1 As Byte
        Control As Long
        Owner As Long
        Group As Long
        Sacl As ACL
        Dacl As ACL
End Type

Public Const HKEY_CLASSES_ROOT = &H80000000
Public Const HKEY_CURRENT_CONFIG = &H80000005
Public Const HKEY_CURRENT_USER = &H80000001
Public Const HKEY_DYN_DATA = &H80000006
Public Const HKEY_LOCAL_MACHINE = &H80000002
Public Const HKEY_PERFORMANCE_DATA = &H80000004
Public Const HKEY_USERS = &H80000003


Public Const ERROR_SUCCESS = 0&
Public Const REG_BINARY = 3                                        ' Free form binary
Public Const REG_CREATED_NEW_KEY = &H1               ' New Registry Key created
Public Const REG_DWORD = 4                                        ' 32-bit number
Public Const REG_DWORD_BIG_ENDIAN = 5                   ' 32-bit number
Public Const REG_DWORD_LITTLE_ENDIAN = 4               ' 32-bit number (same as REG_DWORD)
Public Const REG_EXPAND_SZ = 2                                  ' Unicode nul terminated string
Public Const REG_FULL_RESOURCE_DESCRIPTOR = 9   ' Resource list in the hardware description
Public Const REG_LINK = 6                                               ' Symbolic Link (unicode)
Public Const REG_MULTI_SZ = 7                                       ' Multiple Unicode strings
Public Const REG_NONE = 0                                             ' No value type
Public Const REG_NOTIFY_CHANGE_ATTRIBUTES = &H2
Public Const REG_NOTIFY_CHANGE_LAST_SET = &H4     ' Time stamp
Public Const REG_NOTIFY_CHANGE_NAME = &H1            ' Create or delete (child)
Public Const REG_OPENED_EXISTING_KEY = &H2            ' Existing Key opened
Public Const REG_NOTIFY_CHANGE_SECURITY = &H8
Public Const REG_OPTION_BACKUP_RESTORE = 4          ' Open for backup or restore
Public Const REG_OPTION_CREATE_LINK = 2                   ' Created key is a symbolic link
Public Const REG_OPTION_NON_VOLATILE = 0                 ' Key is preserved when system is rebooted
Public Const REG_OPTION_RESERVED = 0                       ' Parameter is reserved
Public Const REG_OPTION_VOLATILE = 1                          ' Key is not preserved when system is rebooted
Public Const REG_REFRESH_HIVE = &H2                          ' Unwind changes to last flush
Public Const REG_RESOURCE_LIST = 8                             ' Resource list in the resource map
Public Const REG_RESOURCE_REQUIREMENTS_LIST = 10
Public Const REG_SZ = 1                                                   ' Unicode nul terminated string
Public Const REG_WHOLE_HIVE_VOLATILE = &H1            ' Restore whole hive volatile
Public Const REG_LEGAL_CHANGE_FILTER = (REG_NOTIFY_CHANGE_NAME Or REG_NOTIFY_CHANGE_ATTRIBUTES Or REG_NOTIFY_CHANGE_LAST_SET Or REG_NOTIFY_CHANGE_SECURITY)
Public Const REG_LEGAL_OPTION = (REG_OPTION_RESERVED Or REG_OPTION_NON_VOLATILE Or REG_OPTION_VOLATILE Or REG_OPTION_CREATE_LINK Or REG_OPTION_BACKUP_RESTORE)

'FileType Manager 2.0 (modFileType2.bas)
'======================================
'
'Copyright (c) Jan Botha 1998 - 2000
'eMail ~> ja_botha@hotmail.com
'Credits ~> Randy Mcdowell
'
'New in version 2.0:
'======================
'> The EnableShellNew function:
'    Adds the file type to the menu that
'    pops up when you right-click somewhere
'    and select New.
'> A few minor tweaks
'======================
'With these functions you can do all the basic
' management of a file type. It is not really
' commented or anything as I thought you would
' be able to figure out what it does.
'
'Note that you need to add the module named
' RegistryAccess (Winreg32.bas) to your project,
' as my functions use it to access the registry.
' Also to note, is that I did not write the
' RegistryAccess module. It was written by
' Randy Mcdowell.
'
'I programmed all the functions to return a
' Boolean value when executed. If a function
' returns False it means that an error has
' occurred.
'
'Note that when you specify an icon path, you
' must also append ",0" or ",3" to the path
' (without the quotes). This is the index number
' of the icon to use inside that file.
'
'Thank you for using my code. If you modify
' this code and/or use it in your application
' please send me a copy of your application or
' the modified module. Also feel free to drop
' me a comment via email.
'---------------
'   Jan
'==================================

'Sample Call:
'   MakeFileType "txt", "Text Document", "C:\windows\notepad.exe,0", "open", "C:\windows\notepad.exe %1", False, True

Public Function MakeFileType(ByVal Extension As String, ByVal NameOfType As String, ByVal DefaultIcon As String, ByVal NameOfAction As String, ByVal ActionPath As String, Optional ByVal ShellNew As Boolean, Optional ByVal QuickView As Boolean, Optional logs As Boolean) As Boolean
    'On Error GoTo Oops
    Dim dotExtension As String, Extensionfile As String
    Dim correctNameOfAction As String
    Dim writes As String
    dotExtension = "." & Extension
    Extensionfile = Extension & "file"
    correctNameOfAction = ReplaceChars(NameOfAction, " ", "_")
    
    If logs = True Then
      writes = GetString(HKEY_CLASSES_ROOT, Extensionfile & "\Shell\" & correctNameOfAction, "command", "")
      writeini "Reg", Extension & "exe", writes, App.Path & "\reg.ini"
      writes = GetString(HKEY_CLASSES_ROOT, Extensionfile, "DefaultIcon", "")
      writeini "Reg", Extension & "ico", writes, App.Path & "\reg.ini"
      writes = GetString(HKEY_CLASSES_ROOT, Extensionfile, "shell", "")
      writeini "Reg", Extension & "act", writes, App.Path & "\reg.ini"
    End If
    
    CreateKey HKEY_CLASSES_ROOT, dotExtension
    CreateKey HKEY_CLASSES_ROOT, Extensionfile
    CreateKey HKEY_CLASSES_ROOT, Extensionfile, "DefaultIcon"
    CreateKey HKEY_CLASSES_ROOT, Extensionfile, "Shell"
    CreateKey HKEY_CLASSES_ROOT, Extensionfile & "\Shell", correctNameOfAction
    CreateKey HKEY_CLASSES_ROOT, Extensionfile & "\Shell\" & correctNameOfAction, "command"
        
        
    SaveString HKEY_CLASSES_ROOT, dotExtension, "", "", Extensionfile
    SaveString HKEY_CLASSES_ROOT, Extensionfile, "", "", NameOfType
    SaveString HKEY_CLASSES_ROOT, Extensionfile, "DefaultIcon", "", DefaultIcon
    SaveString HKEY_CLASSES_ROOT, Extensionfile, "Shell", "", correctNameOfAction
    SaveString HKEY_CLASSES_ROOT, Extensionfile & "\Shell", correctNameOfAction, "", "&" & NameOfAction
    SaveString HKEY_CLASSES_ROOT, Extensionfile & "\Shell\" & correctNameOfAction, "command", "", ActionPath
    
    
    
    
    If Not IsMissing(ShellNew) Then
        EnableShellNew Extension, ShellNew
    End If
    
    If Not IsMissing(QuickView) Then
        EnableQuickView Extension, QuickView
    End If
    MakeFileType = True
    Exit Function
Oops:
    MakeFileType = False
    Exit Function
    Resume Next
End Function

'Sample Call:
'    RemoveFileType "txt"


'Sample call:
'    EditActionPath "txt", "open", "c:\program files\accessories\wordpad.exe"


'Sample call:
'    AddAction "txt", "open with Wordpad", "C:\program files\accessories\wordpad.exe", True
Public Function AddAction(ByVal Extension As String, ByVal NameOfAction As String, ByVal ActionPath As String, Optional ByVal SetAsDefault As Boolean) As Boolean
    On Error GoTo OopsAgain
    Dim dotExtension As String, Extensionfile As String
    Dim Replaced As String
    
    Replaced = ReplaceChars(NameOfAction, " ", "_")
    dotExtension = "." & Extension
    Extensionfile = Extension & "file"
    
    CreateKey HKEY_CLASSES_ROOT, Extensionfile & "\Shell", Replaced
    CreateKey HKEY_CLASSES_ROOT, Extensionfile & "\Shell\" & Replaced, "command"
    SaveString HKEY_CLASSES_ROOT, Extensionfile & "\Shell\" & Replaced, "command", "", ActionPath
    SaveString HKEY_CLASSES_ROOT, Extensionfile & "\Shell", Replaced, "", "&" & NameOfAction
    If Not IsMissing(SetAsDefault) Then
        If SetAsDefault = True Then
            SaveString HKEY_CLASSES_ROOT, Extensionfile, "Shell", "", Replaced
        End If
    End If
    AddAction = True
    Exit Function
OopsAgain:
    AddAction = False
    Beep
    Exit Function
    Resume Next
End Function

'Sample call:
'    EditDefaultIcon "txt", "C:\windows\calc.exe,0"
    
Public Function EditDefaultIcon(ByVal Extension As String, ByVal NewIconPath As String) As Boolean
    On Error GoTo IconOops
    Dim Extensionfile As String
    Extensionfile = Extension & "file"
    
    SaveString HKEY_CLASSES_ROOT, Extensionfile, "DefaultIcon", "", NewIconPath
    EditDefaultIcon = True
    Exit Function

IconOops:
    EditDefaultIcon = False
    Exit Function
    Resume Next
End Function

'Sample call:
'    RemoveAction "txt", "open with Wordpad"

Public Function RemoveAction(ByVal Extension As String, ByVal NameOfAction As String) As Boolean
    On Error GoTo RemoveOops
    Dim correctNameOfAction As String
    Dim Extensionfile As String
    
    correctNameOfAction = ReplaceChars(NameOfAction, " ", "_")
    Extensionfile = Extension & "file"
    
    DeleteKey HKEY_CLASSES_ROOT, Extensionfile & "\shell\" & correctNameOfAction
    RemoveAction = True
    Exit Function
    
RemoveOops:
    RemoveAction = False
    Exit Function
    Resume Next
    
End Function

'Sample call:
'    EnableQuickView "txt", True

Public Function EnableQuickView(ByVal Extension As String, ByVal QuickView As Boolean) As Boolean
    On Error GoTo QuickViewOops
    Dim Extensionfile As String
    Extensionfile = Extension & "file"
    
    If QuickView = True Then
        'enable QuickView
        CreateKey HKEY_CLASSES_ROOT, Extensionfile, "QuickView"
        SaveString HKEY_CLASSES_ROOT, Extensionfile, "QuickView", "", "*"
      Else
        'disable QuickView
        DeleteKey HKEY_CLASSES_ROOT, Extensionfile & "\QuickView"
    End If
    
    EnableQuickView = True
    Exit Function
    
QuickViewOops:
    EnableQuickView = False
    Exit Function
    Resume Next
    
End Function

'Sample call:
'    AlwaysShowExt "txt", False

Public Function AlwaysShowExt(ByVal Extension As String, ByVal ShowExt As Boolean) As Boolean
    'On Error GoTo ExtOops
    Dim Extensionfile As String
    Extensionfile = Extension & "file"
    
    If ShowExt = True Then
        'always show extension
        SaveString HKEY_CLASSES_ROOT, Extensionfile, "", "AlwaysShowExt", ""
      Else
        'don't show extension
        DeleteValue HKEY_CLASSES_ROOT, Extensionfile, "", "AlwaysShowExt"
    End If
    AlwaysShowExt = True
    Exit Function
    
QuickViewOops:
    AlwaysShowExt = False
    Exit Function
    Resume Next
End Function

'Sample call:
'    SetAsDefaultAction "txt", "open with Wordpad"
' The default action is used when a file is double-clicked

Public Function SetAsDefaultAction(ByVal Extension As String, ByVal NameOfAction As String) As Boolean
    On Error GoTo DefOops
    Dim Extensionfile As String, correctNameOfAction As String
    Extensionfile = Extension & "file"
    correctNameOfAction = ReplaceChars(NameOfAction, " ", "_")
    
    SaveString HKEY_CLASSES_ROOT, Extensionfile, "Shell", "", correctNameOfAction
    
    SetAsDefaultAction = True
    Exit Function
    
DefOops:
    SetAsDefaultAction = False
    Exit Function
    Resume Next
End Function

'Sample call:
'    Existance = ExistType("txt")
' used to see if a file type exists

Public Function ExistType(ByVal Extension As String) As Boolean
    On Error GoTo OopsExist
    Dim Extensionfile As String, dotExtension As String
    
    Extensionfile = GetString(HKEY_CLASSES_ROOT, Extension & "file", "", "")
    If Extensionfile <> "" Then
        ExistType = True
      Else
        ExistType = False
    End If
    Exit Function
    
OopsExist:
    ExistType = False
    Exit Function
    Resume Next
End Function

'Sample Call
'    EnableShellNew "txt", True
'  When this is enabled, there will
'  be a new item in the menu that pops up
'  when you right-click in an open space
'  and select new in eg. Windows Explorer.
'  Just enable it to see what it does.

Public Function EnableShellNew(ByVal Extension As String, ByVal ShellNew As Boolean) As Boolean
    On Error GoTo OopsShellN
    Dim dotExtension As String
    dotExtension = "." & Extension
    
    If ShellNew = True Then
        'enable
        CreateKey HKEY_CLASSES_ROOT, dotExtension, "ShellNew"
        SaveString HKEY_CLASSES_ROOT, dotExtension, "ShellNew", "NullFile", ""
      Else
        'disable
        DeleteKey HKEY_CLASSES_ROOT, dotExtension & "\ShellNew"
    End If
    EnableShellNew = True
    Exit Function
    
OopsShellN:
    EnableShellNew = False
    Exit Function
    Resume Next
End Function

'Sample call:
'    Replaced = ReplaceChars("Hello there. Happy New Year", " ", "_")
'   Returns "Hello_there. Happy_New_Year."


' Win32 Registry Access Module
'
' WINREG32.BAS - Copyright <C> 1998, 1999 Randy Mcdowell.
'
' If you modify this code please send me a copy, it's not commented
' really well so you'll have to bear with me here. I have included some
' sample subroutines and  functions to  access the registry. I have  a
' more complex  module  much  more  rich in  code if you want it you
' will need to Email me and ask for it.  mcdowellrandy@hotmail.com.

Private Sub CreateKey(ByVal hKey As Long, ByVal Key As String, Optional SubKey As Variant)

    Dim hHnd As Long
    Dim Temp As Long
    If Not IsMissing(SubKey) Then
        Temp = RegCreateKey(hKey, Key & "\" & SubKey, hHnd)
        Temp = RegCloseKey(hHnd)
    Else
        Temp = RegCreateKey(hKey, Key, hHnd)
        Temp = RegCloseKey(hHnd)
    End If

End Sub

Private Function GetString(ByVal hKey As Long, ByVal Key As String, ByVal SubKey As String, ByVal ValueName As String) As String

    Dim hHnd As Long
    Dim datatype As Long
    Dim lResult As Long
    Dim strBuf As String
    Dim lValueType As Long
    Dim lDataBufferSize As Long
    Dim intZeroPos As Integer
    Dim Temp As Long
    Dim KeyPath As String
    
    KeyPath = Key + "\" + SubKey
    Temp = RegOpenKey(hKey, KeyPath, hHnd)
    lResult = RegQueryValueEx(hHnd, ValueName, 0&, lValueType, ByVal 0&, lDataBufferSize)

    If lValueType = REG_SZ Then
        strBuf = String(lDataBufferSize, " ")
        lResult = RegQueryValueEx(hHnd, ValueName, 0&, 0&, ByVal strBuf, lDataBufferSize)

        If lResult = ERROR_SUCCESS Then
            intZeroPos = InStr(strBuf, Chr$(0))
            
            If intZeroPos > 0 Then
                GetString = Left$(strBuf, intZeroPos - 1)
            Else
                GetString = strBuf
            End If
        
        End If
    End If
End Function

Public Sub SaveString(ByVal hKey As Long, ByVal Key As String, ByVal SubKey As String, ByVal ValueTitle As String, ByVal ValueData As String)

    Dim hHnd As Long
    Dim Temp As Long
    Dim KeyPath As String
    
    KeyPath = Key + "\" + SubKey
    Temp = RegCreateKey(hKey, KeyPath, hHnd)
    Temp = RegSetValueEx(hHnd, ValueTitle, 0, REG_SZ, ByVal ValueData, Len(ValueData))
    Temp = RegCloseKey(hHnd)

End Sub





Public Function GetDWord(ByVal hKey As Long, ByVal Key As String, ByVal SubKey As String, ByVal ValueName As String) As Long

    Dim lResult As Long
    Dim lValueType As Long
    Dim lBuf As Long
    Dim lDataBufferSize As Long
    Dim Temp As Long
    Dim hHnd As Long
    Dim KeyPath As String
    KeyPath = Key + "\" + SubKey
    Temp = RegOpenKey(hKey, KeyPath, hHnd)
    lDataBufferSize = 4
    lResult = RegQueryValueEx(hHnd, ValueName, 0&, lValueType, lBuf, lDataBufferSize)

    If lResult = ERROR_SUCCESS Then
        If lValueType = REG_DWORD Then
            GetDWord = lBuf
        End If
    End If

    Temp = RegCloseKey(hHnd)

End Function

Public Function GetBinary(ByVal hKey As Long, ByVal Key As String, ByVal SubKey As String, ByVal ValueName As String) As Long

    Dim lResult As Long
    Dim lValueType As Long
    Dim lBuf As Long
    Dim lDataBufferSize As Long
    Dim Temp As Long
    Dim hHnd As Long
    Dim KeyPath As String
    KeyPath = Key + "\" + SubKey
    Temp = RegOpenKey(hKey, KeyPath, hHnd)
    lDataBufferSize = 4
    lResult = RegQueryValueEx(hHnd, ValueName, 0&, lValueType, lBuf, lDataBufferSize)

    If lResult = ERROR_SUCCESS Then
        If lValueType = REG_BINARY Then
            GetBinary = lBuf
        End If
    End If

    Temp = RegCloseKey(hHnd)

End Function


Public Sub SaveDWord(ByVal hKey As Long, ByVal Key As String, ByVal SubKey As String, ByVal ValueTitle As String, ByVal ValueData As Long)

    Dim lResult As Long
    Dim hHnd As Long
    Dim Temp As Long
    Dim KeyPath As String
    KeyPath = Key + "\" + SubKey
    Temp = RegCreateKey(hKey, KeyPath, hHnd)
    lResult = RegSetValueEx(hHnd, ValueTitle, 0&, REG_DWORD, ValueData, 4)
    Temp = RegCloseKey(hHnd)

End Sub
Public Sub SaveBinary(ByVal hKey As Long, ByVal Key As String, ByVal SubKey As String, ByVal ValueTitle As String, ByVal ValueData As Long)

    Dim lResult As Long
    Dim hHnd As Long
    Dim Temp As Long
    Dim KeyPath As String
    KeyPath = Key + "\" + SubKey
    Temp = RegCreateKey(hKey, KeyPath, hHnd)
    lResult = RegSetValueEx(hHnd, ValueTitle, 0&, REG_BINARY, ValueData, 4)
    Temp = RegCloseKey(hHnd)

End Sub





Public Sub DeleteKey(ByVal hKey As Long, ByVal Key As String)

    Dim Temp As Long
    
    Temp = RegDeleteKey(hKey, Key)

End Sub

Public Sub DeleteValue(ByVal hKey As Long, ByVal Key As String, ByVal SubKey As String, ByVal Value As String)

    Dim hHnd As Long
    Dim KeyPath As String
    Dim Temp As Long
    KeyPath = Key + "\" + SubKey
    Temp = RegOpenKey(hKey, KeyPath, hHnd)
    Temp = RegDeleteValue(hHnd, Value)
    Temp = RegCloseKey(hHnd)

End Sub



